<cfsetting enablecfoutputonly="Yes">
<!--- 

	fourqTree custom tag
	
	Originally written for the NSW Board of Studies
	
	Released under Common Public License 1.0
	http://opensource.org/licenses/cpl.php

	Description:
	Custom tag that builds an unordered HTML list based on a fourq tree query

	Based upon farcry_core/tags/webskin/sitemap.cfm (v1.11) written by Daemon (www.daemon.com.au)

	Created: 20 March 2004 by Tim Lucas <t.lucas@toolmantim.com>
	Last modified: 08 Sept 2004 by Gavin Cooney <gavin.cooney@gmail.com>

	Attributes:
	- attributes.qTreeNav - required
	- attributes.bDisplay - default="false"
	- attributes.r_sTree - default="r_sTree"
	- attributes.bFollowSymLinks - default="true" - regular farcry symlink behaviour
	- attributes.bHighlightAncestors - default="false"
	- attributes.bHightlightObject - default="false"
	- attributes.sHighlightClass - default="active"
	- attributes.sHighlightObjectid - required for bHighlightAncestors
	- attributes.sID - id to apply to the unordered list
	- attributes.sUlTitle - title to apply to the unordered list
--->
<cfif thistag.executionMode eq "Start">

<cfimport taglib="/farcry/farcry_core/tags/webskin" prefix="skin">
<cfimport taglib="/farcry/arc_phase4/tags/webskin" prefix="myskin">

<cfparam name="attributes.qTreeNav" type="query">
<cfparam name="attributes.bDisplay" type="boolean" default="true">
<cfparam name="attributes.r_sTree" type="string" default="r_sTree">
<cfparam name="attributes.bFollowSymLinks" type="boolean" default="true">
<cfparam name="attributes.bHighlightAncestors" type="boolean" default="false">
<cfparam name="attributes.bHighlightObject" type="boolean" default="false">
<cfparam name="attributes.sHighlightClass" type="string" default="active">
<cfif attributes.bHighlightAncestors>
	<cfparam name="attributes.sHighlightObjectid" type="uuid">
</cfif>
<cfparam name="attributes.sID" type="string" default="">
<cfparam name="attributes.sUlTitle" type="string" default="">

<cfif attributes.bFollowSymLinks>
	<cfparam name="attributes.qTreeNav.externallink">
</cfif>

<!--- check the query nav has everything we need --->
<cfparam name="attributes.qTreeNav.nlevel">
<cfparam name="attributes.qTreeNav.objectid">
<cfparam name="attributes.qTreeNav.objectname">

<cfscript>
	qNav = attributes.qTreeNav;
	lv0 = qNav.nlevel[1]; // nlevel for plateau
	depth = lv0; // default depth ie. plateau
	
	// Get ancestor list if we need to highlight them
	if(attributes.bHighlightAncestors) {
		qAnc = application.factory.oTree.getAncestors(objectid="#attributes.sHighlightObjectid#", bIncludeSelf=1);
		lAncestors = ValueList(qAnc.objectid);
	}
	
	// Add empty externallink column if it doesn't exist
	if(not ListContainsNoCase(qNav.columnlist,"externallink")) {
		QueryAddColumn(qNav,"externallink",ArrayNew(1));
	}
</cfscript>

<cfsavecontent variable="sTree">
	<cfif qNav.recordcount gt 0>
	<cfoutput>
	<ul<cfif attributes.sID neq ""> id="#attributes.sID#"</cfif><cfif len(attributes.sUlTitle)> title="#attributes.sUlTitle#"</cfif>>
	</cfoutput>
	</cfif>
	
	<cfloop query="qNav">

		<cfscript>
		if (qNav.nlevel eq depth) {
			// do nothing
		} else if (qNav.nlevel gt depth) {
			// depth increase indent
			writeoutput('
		<ul>');
			depth=depth+1;
		} else if (qNav.nlevel lt depth) {
			// depth decrease outdent
			for (i=1;qNav.nlevel - depth;i=1+1)
			{
				writeoutput('
		</ul>
		</li>');
				depth=depth-1;
			}
		}
		// next depth
		nextrow = qnav.currentrow+1;
		nextdepth=qnav.nlevel[nextrow];
		</cfscript>
		
		<cfoutput>
		<li<cfif (attributes.bHighlightAncestors AND ListContains(lAncestors,qNav.objectid)) or (attributes.bHighlightObject AND qNav.objectid eq attributes.sHighlightObjectid)> class="#attributes.sHighlightClass#"</cfif>></cfoutput><myskin:buildLink objectid="#qNav.objectid#" externallink="#Iif(attributes.bFollowSymLinks,DE(qNav.externallink),DE(''))#"><cfoutput>#qNav.objectname#</cfoutput></myskin:buildLink>
		<!--- Only close the <li> if next row isn't nested --->
		<cfif nextdepth eq "" or qNav.nlevel gte nextdepth><cfoutput></li></cfoutput></cfif>

	</cfloop>
	
	<!--- Check if nested list --->
	<cfif depth neq lv0>
		<cfloop from="1" to="#depth - lv0#" index="i">

			<cfif i eq 1>
				<cfoutput>
		</ul></cfoutput>

			<!--- check if middle iteration --->
			<cfelseif i neq depth - lv0>
			<cfoutput>
		</li></ul></cfoutput>

			<!--- check if end iteration --->
			<cfelse>
			<cfoutput>
		</li></ul>
		</li></cfoutput>
			</cfif>
		</cfloop>
	</cfif>
	
	<cfif qNav.recordcount gt 0>
	<cfoutput>
	</ul>
	</cfoutput>
	</cfif>

</cfsavecontent>

<cfif attributes.bDisplay>
	<cfoutput>#sTree#</cfoutput>
<cfelse>
	<!--- return tree string to calling page --->
	<cfset "caller.#attributes.r_sTree#" = sTree>
</cfif>

</cfif>
<cfsetting enablecfoutputonly="no">